Class {
	#name : #BaselineOfMiniDocs,
	#superclass : #BaselineOf,
	#category : #BaselineOfMiniDocs
}

{ #category : #accessing }
BaselineOfMiniDocs >> baseline: spec [
	<baseline>
	spec
		for: #common
		do: [ 
			"Dependencies"
			spec 
				baseline: 'Mustache' with: [ spec repository: 'github://noha/mustache' ];
				baseline: 'Tealight' with: [ spec repository: 'github://astares/Tealight:main/src' ];
				baseline: 'LepiterBuildingBlocs' with: [spec repository: 'github://botwhytho/LepiterBuildingBlocs:main/src'];
				baseline: 'PetitParser' with: [
					spec
						loads: #('Minimal' 'Core' 'Tests' 'Islands');
						repository: 'github://moosetechnology/PetitParser:v3.x.x/src'
				].
			"self fossil: spec."
			self xmlParserHTML: spec.
			"Packages"
			spec
				package: 'PetitMarkdown' with: [ spec requires: #('PetitParser')];
				package: 'MiniDocs' with: [ spec requires: #('Mustache' 'Tealight' 'PetitMarkdown')].
			
			"Groups"
			
		].
	spec
		
]

{ #category : #accessing }
BaselineOfMiniDocs >> fossil: spec [ 
	| repo |
	repo := ExoRepo new
   		repository: 'https://code.sustrato.red/Offray/Fossil'.
	repo load.
	spec baseline: 'Fossil' with: [ spec repository: 'gitlocal://', repo local fullName ]
]

{ #category : #accessing }
BaselineOfMiniDocs >> semanticVersion [
	^ '0.2.0'
]

{ #category : #accessing }
BaselineOfMiniDocs >> xmlParserHTML: spec [
	Metacello new
		baseline: 'XMLParserHTML';
		repository: 'github://pharo-contributions/XML-XMLParserHTML/src';
		onConflict: [ :ex | ex useLoaded ];
    	onUpgrade: [ :ex | ex useLoaded ];
    	onDowngrade: [ :ex | ex useLoaded ];
    	onWarningLog;
		load.
	spec baseline: 'XMLParserHTML' with: [spec repository: 'github://pharo-contributions/XML-XMLParserHTML/src']
]
