Extension { #name : #LeGitHubSnippet }

{ #category : #'*MiniDocs' }
LeGitHubSnippet >> metadataUpdate [
	| createEmailSanitized editEmailSanitized |
	createEmailSanitized := self createEmail asString withoutXMLTagDelimiters.
	editEmailSanitized := self editEmail asString withoutXMLTagDelimiters.
	^ OrderedDictionary new
		  at: 'id' put: self uidString;
		  at: 'parent' put: self parent uuid;
		  at: 'created' put: self createTime asString;
		  at: 'modified' put: self latestEditTime asString;
		  at: 'creator' put: createEmailSanitized;
		  at: 'modifier' put: editEmailSanitized;
		  yourself
]

{ #category : #'*MiniDocs' }
LeGitHubSnippet >> sanitizeMetadata [
	self metadata keysAndValuesDo: [:k :v |
		(v includesAny: #($< $>))
			ifTrue: [
				self metadata at: k put: (v copyWithoutAll: #($< $>)) 
			]
	]
]
