Extension { #name : #LeHomeDatabaseHeaderElement }

{ #category : #'*MiniDocs' }
LeHomeDatabaseHeaderElement >> importMinidocsButtonElement [
	^ self userData at: 'importMinidocsButtonElement' ifAbsentPut: [ self newImportMiniDocsButton]
]

{ #category : #'*MiniDocs' }
LeHomeDatabaseHeaderElement >> initialize [
	super initialize.
	self initializeEditableTitleElement.
	self initializeButtons.
	
	self addChild: self toolbarElement as: #toolbar.
	self toolbarElement 
		addItem: self editableTitleElement;
		addItem: self newAddNewPageButton;
		addItem: self removeButtonElement;
		addItem: self importButtonElement;
		addItem: self exportButtonElement;
		addItem: self importMinidocsButtonElement.
	
	self addAptitude: (BrLayoutResizerAptitude new
		hInherit;
		vAnyToFitContent; 
		hInherit: self toolbarElement;
		vAnyToFitContent: self toolbarElement).
]

{ #category : #'*MiniDocs' }
LeHomeDatabaseHeaderElement >> initializeButtons [
	self initializeRemoveButton.
	self initializeImportButton.
	self initializeExportButton.
	self initializeMiniDocsImportButton.
]

{ #category : #'*MiniDocs' }
LeHomeDatabaseHeaderElement >> initializeMiniDocsImportButton [
	"importMinidocsButtonElement := self newImportMiniDocsButton."
	self userData at: 'importMinidocsButtonElement' put: self newImportMiniDocsButton.
]

{ #category : #'*MiniDocs' }
LeHomeDatabaseHeaderElement >> newImportMiniDocsButton [
	^ LeMiniDocsImport new
		tooltip: 'Import MiniDocs from url';
		contentExtent: 200 @ 30
]

{ #category : #'*MiniDocs' }
LeHomeDatabaseHeaderElement >> updateToolbarButtons [
	self updateRemoveButtonElement.
	self exportButtonElement database: self database.
	self importButtonElement database: self database.
	self importMinidocsButtonElement database: self database.
]
