Extension { #name : #LeTextSnippet }

{ #category : #'*MiniDocs' }
LeTextSnippet >> asLePage [
	| page |
	page  := LePage new
		initializeTitle: self contentAsString.
	self database addPage: page.
	self childrenDo: [:child |
		child moveToPageTitled: page title
	].
	self removeSelfCommand.
	^ page.
]

{ #category : #'*MiniDocs' }
LeTextSnippet >> fromMarkdeep: markdeepDiv [

	^ markdeepDiv asSnippetDictionary asLepiterSnippet
]

{ #category : #'*MiniDocs' }
LeTextSnippet >> fromString: aString [

self string: aString
]

{ #category : #'*MiniDocs' }
LeTextSnippet >> metadata [
	
	^ self metadataUpdate
]

{ #category : #'*MiniDocs' }
LeTextSnippet >> options [
	^ options
]

{ #category : #'*MiniDocs' }
LeTextSnippet >> parentId [
	self parent ifNil: [ ^ self ].
	(self parent isString) ifTrue: [^ self parent].
	^ self parent uidString. 
]

{ #category : #'*MiniDocs' }
LeTextSnippet >> taggedWith: aString [ 
	self metadata at: 'tags' ifPresent: [  (self metadata at: 'tags') add: aString; yourself ] ifAbsentPut: [ Set new ].
	^ self metadata at: 'tags'
]
