Class {
	#name : #PPCMPlainLine,
	#superclass : #PPCMNode,
	#instVars : [
		'text'
	],
	#category : #'PetitMarkdown-AST'
}

{ #category : #'as yet unclassified' }
PPCMPlainLine class >> empty [
	^ self new
		text: '';
		yourself
]

{ #category : #visiting }
PPCMPlainLine >> accept: visitor [
	^ visitor visitPlainLine: self
]

{ #category : #accessing }
PPCMPlainLine >> isBlankLine [
	^ self text = ''
]

{ #category : #accessing }
PPCMPlainLine >> isLine [
	^ true
]

{ #category : #visiting }
PPCMPlainLine >> text [
	^ text
]

{ #category : #visiting }
PPCMPlainLine >> text: whatever [
	text := whatever
]

{ #category : #accessing }
PPCMPlainLine >> viewBody [

	| aText |
	aText := (self className ,' ', self text) asRopedText.

	self children do: [ :child | 
		aText append: ' ' asRopedText.
		aText append: (child text asRopedText foreground:
				 BrGlamorousColors disabledButtonTextColor).
		aText append: ('= "' asRopedText foreground:
				 BrGlamorousColors disabledButtonTextColor).
		aText append: (child text asRopedText foreground:
				 BrGlamorousColors disabledButtonTextColor).
		aText append:
			('"' asRopedText foreground:
				 BrGlamorousColors disabledButtonTextColor) ].


	^ aText
]
